// menu ovladane 3 tlacitky se zobrazovanim na displeji
//======================================================

#ifdef displej_TM1637_5


#define AUTOEXITMENU        3000      //  po jake dobe necinnosti se menu automaticky opusti (cislo udava pocet smycek, jedna smycka trva 100ms) 
unsigned int auto_exit_menu;          // v teto promenne se bude odecitat doba necinnosti
unsigned long trvani_stisku;          // doba drzeni tlacitka OK v milisekundach v hlavnim menu
unsigned long trvani_stisku2;         // doba drzeni tlacitka OK v milisekundach v podmenu

unsigned long start_UD;               // promenne pro automaticke listovani pri dlouhem stisku tlacitek nahoru a dolu
unsigned int cas_UD;
boolean auto_UD;

int pozice_menu1;       // nalistovana pozice v hlavnim menu
                        // 0 = LIST           (listovani v poslednich namerenych hodnotach)
                        // 1 = Auto:          (nastaveni automatickeho zaznamu)
                        // 2 = ZonA:          (prepinani LETO/ZIMA - SEC/SELC)
                        // 3 = CALIb:         (zobrazeni a ulozeni jasu bez prepoctu)
                        // 4 = dAtuM:         (zobrazeni a moznost nastaveni datumu)
                        // 5 = CAS:           (zobrazeni a moznost nastaveni casu)
                        // 6 = tEPL:          (prubezne zobrazovani aktualni teploty)
                        // 7 = VLH:           (prubezne zobrazovani aktualni vlhkosti)
                        // 8 = JAS:           (prubezne zobrazovani aktualniho jasu)
                        // 9 = Ho-Mi:         (prubezne zobrazovani aktualniho casu)
                        //10 = PruM:          (nastaveni prumerovani)
                        //11 = LEd:           (regulovatelna cervena svitilna)
                        //12 = StoP:          (Stopky)
                        //13 = GPS:           (zobrazeni zemepisnych souradnic) - jen kdyz je pripojeny GPS modul a jsou k dispozici data
                        //14 = Stan           (prednastavene pozorovaci stanoviste misto GPS)
                        //15 = Spec           (specialni sunkce)
                        //22 = uHEL           (naklonomer)         
                        //23 = 5L-ME          Aktualni poloha Slunce a Mesice
                        //24 = OdPOc          Odpocet (budik, casovac)

// listovani v hlavnim menu a volba polozky
void menu_1(void)
  {
    unsigned long posledni_prepnuti;               // prepinani polozek je mozne za urcitou dobu od posledni zmeny
    byte pocet_polozek_menu = pocet_polozek_v_menu + 1;  // maximalni pocet pocet polozek (+1) pres ktere se listuje (nezalezi na tom, jestli jsou pouzite)



// moznost rucne omezit nektere polozky v menu
    pole_zobr_menu[0] = true;   // LIST
    pole_zobr_menu[1] = true;   // Auto
    pole_zobr_menu[2] = true;   // ZonA
    pole_zobr_menu[3] = true;   // CALIb
    pole_zobr_menu[4] = true;   // dAtuM
    pole_zobr_menu[5] = true;   // CAS
    pole_zobr_menu[6] = true;   // tEPL
    pole_zobr_menu[7] = true;   // VLH
    pole_zobr_menu[8] = true;   // JAS
    pole_zobr_menu[9] = true;   // Ho-Mi
    pole_zobr_menu[10] = true;  // PruM
    pole_zobr_menu[11] = true;  // LEd
    pole_zobr_menu[12] = true;  // StoP
    pole_zobr_menu[13] = false;  // GPS        polozka se povoluje automaticky podle toho, jestli je GPS zasunute a povolene
    pole_zobr_menu[14] = true;   // 5tAn       (Stan) Prednastavene pozorovaci stanoviste kdyz neni zasunuty GPS modul
    pole_zobr_menu[15] = false;  // #SPEC      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[16] = false;  // #PAr1      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[17] = false;  // #PAr2      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[18] = false;  // #PAr3      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[19] = false;  // #FCE1      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[20] = false;  // #FCE2      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[21] = false;  // #CoPy      polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[22] = false;  // uHEL       polozka se povoluje automaticky podle typu zasunuteho specialniho HW
    pole_zobr_menu[23] = true;   // 5L-ME
    pole_zobr_menu[24] = true;   // odPoc



#ifdef naklonomer
    pole_zobr_menu[22] = true;                                               // uHEL
#endif

#ifdef ukladat_GPS
        if (digitalRead(pin_EXT_ZAP) == LOW)                                 // kdyz je GPS povolene a zasunute, tak se polozka bude zobrazovat
          {
            pole_zobr_menu[13] = true;                                       // polozku GPS zobrazit
            pole_zobr_menu[14] = false;                                      // polozku Stan nezobrazit
          }
        else
          {
            pole_zobr_menu[13] = false;                                      // polozku GPS nezobrazit
            pole_zobr_menu[14] = true;                                       // polozku Stan zobrazit            
          }
#endif


    auto_exit_menu = AUTOEXITMENU;                                           // po 5 minutach bez stisku tlacitka se menu automaticky ukonci
    if (prvni_vstup_do_menu == true)                                         // pri prvnim vstupu do menu po zapnuti napajeni najde prvni zobrazitelnou polozku
      {
        for (byte po = 0; po < pocet_polozek_menu ; po++)                    // pri vypnuti nejake polozky menu v uvodnich definicich programu se tady tato polozka skutecne zakaze
          {
            if (menu_enable[po] == false) pole_zobr_menu[po] = false;
          }

        
        // pro pripad, ze by nekdo zakazal vsechny polozky krome tech, ktere se stejne nezobrazuji bylo nutne porovnat dve pole
        boolean menu_dostupne = false;
        for (byte po = 0; po <= pocet_polozek_v_menu ; po ++)
          {
            if (menu_enable[po] == true and pole_zobr_menu[po] == true)  // byla nalezena alespon jedna polozka k zobrazeni
              {
                menu_dostupne = true;
                pozice_menu1 = po;
                break;                                         // yvpadnuti ze smycky for
              }
          }
        if (menu_dostupne == false)                            // zadna polozka se nema zobrazovat
          {
            while (digitalRead(pin_tl_ok) == LOW) delay(100);  // cekani na uvolneni tlacitka OK s odrusenim zakmitu
            delay(100);
            return;                                            // zadne menu se nezobrazi a po uvolneni tlacitka OK se vrati program zpatky do hlavni smycky
          }
      }
              
    prvni_vstup_do_menu = false;
    zobraz_text(pozice_menu1);

    while (digitalRead(pin_tl_ok) == LOW)                                    // do hlavniho menu se vstoupilo dlouhym stiskem tlacitka OK
      {                                                                      //  ted je nutne pockat na jeho uvolneni
        delay(20);
        if (digitalRead(pin_tl_ok) == HIGH) delay(50);                       // kdyz se behem drzeni tlacitka ok objevi kratky vypadek kontaktu, tak se odignoruje        
      }

    delay(50);
    
    while (auto_exit_menu > 0)
      {     
        interrupty();                                                        // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
       
        if (digitalRead(pin_EXT_ZAP) == LOW)                                 // pri zasunuti GPS (nebo jine externi desky) se zrusi prednastavene pozorovaci stanoviste
          {
            if ((EEPROM_read(48) & 0b11100000) > 0)                          // zrusi se ale jen v pripade, ze je nejake nastavene (aby se porad dokola neprepisovala jedna bunka EEPROM)
              {
                EEPROM_update(48,(EEPROM_read(48) & 0b00011111));            // smazat nejvyssi 3 bity z adresy 48
              }
          }
        
        
        if (pozice_menu1 == 13 and pole_zobr_menu[13] == false ) pozice_menu1 = 14;  // okamzita aktualizace napisu pro pripad, ze dojde k vytazeni nebo zasunuti GPS modulu
        if (pozice_menu1 == 14 and pole_zobr_menu[14] == false ) pozice_menu1 = 13;

        zobraz_text(pozice_menu1);        


        if (digitalRead(pin_tl_up) == HIGH and digitalRead(pin_tl_dn) == HIGH)       //obe uvolnena tlacitka nahoru a dolu rusi funkci automatickeho listovani
          {
            auto_UD = false;
            delay(100);    
          }
        
        if (digitalRead(pin_tl_up) == LOW and (millis()-posledni_prepnuti) > 100)    // listovani nahoru v hlavnim menu (k nizsim indexum polozek v menu)
          {
            cas_UD = 150;                                                    // automaticke listovani v menu (cas mezi automatickym prepinanim polozek)
            start_UD = millis();                                             // znacka pro porovnani, jestli uz doslo k prekroceni pozadovaneho casu
            if (auto_UD == false)                                            // pri prvnim stisku se nastavi delsi cas prepnuti
              {
                auto_UD = true;
                cas_UD = 1000;                                               // cas pred automatickym prepnutim na druhou polozku po stisku tlacitka je trochu delsi
              }
              
            pozice_menu1 --;
            if (pozice_menu1 < 0) pozice_menu1 = 0;
            while (pole_zobr_menu[pozice_menu1] == false)                    // kdyz je zvolena polozka nezobrazitelna, prepne se na dalsi nizsi
              {
                pozice_menu1 --;
                if (pozice_menu1 < 0)
                  {
                    pozice_menu1 = 0;
                    break;                                                   // pri podteceni pod nultou polozku se vypadne
                  }
              }

            while (pole_zobr_menu[pozice_menu1] == false)                    // pokud se z predchozi smycky vystoupi pres podteceni nulove polozky
              {
                pozice_menu1 ++;                                             // postupnym zvysovanim indexu se hleda nejnizsi povolena polozka
              }
            
            zobraz_text(pozice_menu1);            
            
            while (digitalRead(pin_tl_up) == LOW and (millis() - start_UD) < cas_UD)      // dokud je tlacitko stisknute a zaroven nedoslo k vyhodnoceni dlouheho stisku, nic se nedeje
              {
                delay(20);
                if (digitalRead(pin_tl_up) == HIGH) delay(50);               // kdyz se behem drzeni tlacitka UP objevi kratky vypadek kontaktu, tak se odignoruje        
              }
            delay(100);                                                      // odruseni zakmitu
            posledni_prepnuti = millis();
            auto_exit_menu = AUTOEXITMENU;
          }

    
        if (digitalRead(pin_tl_dn) == LOW and (millis()-posledni_prepnuti) > 100) // listovani dolu v hlavnim menu (k vyssim indexum polozek v menu)
          {
            cas_UD = 150;                                                    // automaticke listovani v menu (cas mezi automatickym prepinanim polozek)
            start_UD = millis();                                             // znacka pro porovnani, jestli uz doslo k prekroceni pozadovaneho casu
            if (auto_UD == false)                                            // pri prvnim stisku se nastavi delsi cas prepnuti
              {
                auto_UD = true;
                cas_UD = 1000;                                               // cas pred automatickym prepnutim na druhou polozku po stisku tlacitka je trochu delsi
              }
              
            pozice_menu1 ++;
            while (pole_zobr_menu[pozice_menu1] == false)                    // kdyz je zvolena polozka neaktivni, prepne se na dalsi vyssi
              {
                pozice_menu1 ++;
                if (pozice_menu1 > pocet_polozek_menu)
                  {
                    pozice_menu1 = pocet_polozek_menu;
                    break;                                                   // pri preteceni maximalniho poctu polozek se ze smycky vypadne
                  }
              }

            while (pole_zobr_menu[pozice_menu1] == false)                    // pokud se z predchozi smycky vystoupi pres prekroceni horni hranice poctu polozek
              {
                pozice_menu1 --;                                             // postupnym snizovanim indexu se hleda nejvyssi povolena polozka
              }

            zobraz_text(pozice_menu1);
            
            while (digitalRead(pin_tl_dn) == LOW and (millis() - start_UD) < cas_UD)      // dokud je tlacitko stisknute a zaroven nedoslo k vyhodnoceni dlouheho stisku, nic se nedeje
              {
                delay(20);
                if (digitalRead(pin_tl_dn) == HIGH) delay(50);                // kdyz se behem drzeni tlacitka DN objevi kratky vypadek kontaktu, tak se odignoruje        
              }
            delay(100);                                                       // odruseni zakmitu
            posledni_prepnuti = millis();
            auto_exit_menu = AUTOEXITMENU;    
          }
    
      
    
        if (digitalRead(pin_tl_ok) == LOW)                                   // potvrzovaci tlacitko
          {
            delay(50);                                                       // odruseni zakmitu
            unsigned long startTime = millis();
            while (digitalRead(pin_tl_ok) == LOW)                            // dokud je tlacitko stisknute, nic se nedeje
              {
                delay(20);
                trvani_stisku = millis() - startTime;
                if (trvani_stisku > 500)                                     // stisk trval dele nez 0,5 sekundy
                  {
                    podmenu(pozice_menu1);                                   // skoci se do podmenu - pri navratu z menu zustava nastavena promenna 'trvani_stisku' na vysokou hodnotu, takze se hlavni menu neopusti
                  }

                if (digitalRead(pin_tl_ok) == HIGH) delay(50);               // kdyz se behem drzeni tlacitka OK objevi kratky vypadek kontaktu, tak se odignoruje

              }
            if (trvani_stisku <= 500)                                        // stisk tlacitka OK byl kratsi, nez 0,5 sekundy
              {
                auto_exit_menu = 1;                                          // pri kratkem stisku se opusti hlavni menu    
                zobraz_text(28);                                             // pri opusteni menu se zhasne displej
                delay(100);                                                  // pauza pred opustenim menu
              }
              
            
          }
        
        auto_exit_menu --;
      
      }                                                                      // kdyz je auto_exit_menu = 0, menu se opousti

    zobraz_text(28);                                                         // pri opusteni menu se zhasne displej 
  
  }
//------------------------------------------



//------------------------------------------
void podmenu(byte polozka)
  {
    int zadano;
    if (polozka == 14)                                                       // polozka 14 ("Stan") je trochu specialni - tam se misto pomlcek zhasne displej
      {                                                                      //    pomlcky znamenaji nenastavene pozorovaci stanoviste, proto se tady nezobrazuji
        zobraz_text(28);                                                     // "     "
      }
    else                                                                     // pro vsechny ostatni polozky se dlouhym stiskem zobrazi pomlcky
      {
        zobraz_text(29);                                                     // vsechny jednotky zobrazi "-----" a ceka se na uvolneni tlacitka (v podprogramu plusminus)    
      }

    while (digitalRead(pin_tl_ok) == LOW)                                    // do podmenu se vstoupilo dlouhym stiskem tlacitka OK
      {                                                                      //  ted je nutne pockat na jeho uvolneni
        delay(20);
        if (digitalRead(pin_tl_ok) == HIGH) delay(50);                       // kdyz se behem drzeni tlacitka ok objevi kratky vypadek kontaktu, tak se odignoruje        
      } 
    delay(50);


    if (polozka == 0)                                                        // LIST
      {
        zadano = plusminus('L', list,0,99);

        if (bude_save == true)                                               // kdyz se z podprogramu 'plusminus()' vyskocilo dlouhym stiskem [OK], zobrazi se jedna polozka v EEPROM
          {
            list = zadano & 255;
            vypis_EEPROM(65531,0);
          }                                                                  // pri navratu z podporgramu 'plusminus()' kratkym stiskem [OK], se EEPROM nevypise a vrati se na polozku 'LIST'
      }

    
    
    if (polozka == 1)                                                        // pocet minut mezi automatickym merenim
      {
        zadano = plusminus('A', automat,0,255);
        EEPROM_update(10,zadano & 255);
        automat = zadano & 255;
        if (automat > 0)                                                     // pokud byl zadany nejaky casovy interval,
          {
            posledni_autospusteni = millis();                                // spusti se prvni mereni okamzite
            mereni(6);         
          }
      }



    if (polozka == 2)                                                        // SEC/SELC
      {
        zadano = plusminus('S', leto,0,1);
        EEPROM_update(8,zadano & 255);

        if ((zadano & 255) == 0) leto = false;
        else                     leto = true;
      }


    if (polozka == 3)                                                        // svetlo bez korekce pro kalibraci
      {
        delay(1000);
        mereni(7);                                                           //  prumeruje 10 vzorku, ale vystup vraci bez korekce. Na zaver vystledek zobrazi na displeji
        
        while (digitalRead(pin_tl_ok) == HIGH)                               // dokud je tlacitko OK uvolnene, je videt hodnota svetla bez korekce
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni            
            delay(20);

            if (digitalRead(pin_tl_up) == LOW)                               // prepnuti na zobrazeni posledni nezkorigovane teploty
              { 
                pozice_tecky = 2;                                            // teplota na 2 destinna mista
                zobraz_cislo((int_teplota  - 5000 ), 1);                          
                D_pamet[4] = znak_stupen; 
              }

            if (digitalRead(pin_tl_dn) == LOW)                               // prepnuti na zobrazeni posledniho nezkorigovaneho jasu
              {
                pozice_tecky = 3;                                            // svetlo na 3 desetinna mista   
                zobraz_cislo(int_svetlo , 0);
              }          
          } 
        
        delay(20);
      }



    if (polozka == 4)                                                        // datum
      {
        boolean pomprom_save = false;
        zobraz_RTC(false);                                                   // cas z RTC rozlozi do promennych "LOC_xxx" (vcetne korekci)
        
        // uprava promennych pomoci tlacitek       
        byte zadany_den = plusminus('d', LOC_den,1,31);
        if (bude_save == true) pomprom_save = true;

        byte zadany_mesic = plusminus('M', LOC_mes,1,12);
        if (bude_save == true) pomprom_save = true;

        if (LOC_rok < 2000) LOC_rok = 2000;                                  // kdyz jeste neni nastaveny cas v RTC, tak je rok nesmyslny, proto se upravi na '2000'
      
        byte zadany_rok = plusminus('r', LOC_rok - 2000,0,99);
        if (bude_save == true) pomprom_save = true;

                                                                             // v promennych 'zadany_den' (/ mesic / rok) jsou upravene hodnoty

        if (pomprom_save == true)
          {

            mtt.year     = zadany_rok + 2000 - 1970;                         // knihovna je napsana tak, ze se cas pocita od 1.1.1970
            mtt.month    = zadany_mesic;
            mtt.day      = zadany_den;
            mtt.hour     = LOC_hod;
            mtt.minute   = LOC_min;
            mtt.second   = LOC_sek;

                                          
            if (leto == false) tt = rtclock.makeTime(mtt) - (60*60*zimni_posun);    // v zime se pri ukladani casu uklada do RTC o hodinu mene (prevod SEC na UTC)
            else               tt = rtclock.makeTime(mtt) - (60*60*letni_posun);    // kdyz se nastavuje cas v lete (SELC), do RTC se uklada o dalsi hodinu mene (prevod SELC na SEC)

            rtclock.setTime(tt);   

            cas_minuleho_nastaveni = 0;                                      // zruseni automatickych korekci casu
            korekce = 0x7FFFFFFFUL;
            EEPROM_write_long(0,cas_minuleho_nastaveni);                     // do EEPROM se ulozi cas posledniho nastaveni (aktualni cas) a vypoctena korekce
            EEPROM_write_long(4,korekce);            
          }
         
      }


    if (polozka == 5)                                                        // cas
      {
        boolean pomprom_save = false;
        zobraz_RTC(false);                                                   // cas z RTC rozlozi do promennych "LOC_xxx" (vcetne korekci)
        
        byte zadane_hodiny = plusminus('H', LOC_hod,0,23);
        if (bude_save == true) pomprom_save = true;
        

        byte zadane_minuty = plusminus('M', LOC_min,0,59);
        if (bude_save == true) pomprom_save = true;

        if (pomprom_save == true)
          {
            mtt.year     = LOC_rok - 1970;                                   // knihovna je napsana tak, ze se cas pocita od 1.1.1970
            mtt.month    = LOC_mes;
            mtt.day      = LOC_den;
            mtt.hour     = zadane_hodiny;
            mtt.minute   = zadane_minuty;
            mtt.second   = 0;

            if (leto == false) tt = rtclock.makeTime(mtt) - (60*60*zimni_posun);    // v zime se pri ukladani casu uklada do RTC o hodinu mene (prevod SEC na UTC)
            else               tt = rtclock.makeTime(mtt) - (60*60*letni_posun);    // kdyz se nastavuje cas v lete (SELC), do RTC se uklada o dalsi hodinu mene (prevod SELC na SEC)

            rtclock.setTime(tt);   

            cas_minuleho_nastaveni = 0;                                      // zruseni automatickych korekci casu
            korekce = 0x7FFFFFFFUL;
            EEPROM_write_long(0,cas_minuleho_nastaveni);                     // do EEPROM se ulozi cas posledniho nastaveni (aktualni cas) a vypoctena korekce
            EEPROM_write_long(4,korekce);  
          }
      }


    if (polozka == 6)                                                        // teplota
      {
        delay(500);
        byte pauza = 0;

        boolean s_korekci = true;                                            // pri vstupu do polozky se vzdycky nejdriv zobrazuje teplota s korekci podle kalibracni tabulky

        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            
            pauza ++;
            if (pauza == 200)                                                // teplota se testuje kazde 2 sekundy (200 x 0.01s)
              {
                int pomprom = teplota(s_korekci);

                pauza = 0;
                D_pamet[4] = znak_stupen;                                    // znacka "stupen" pro mereni teploty na prvni zobrazovaci jednotce (rad desetitisicu)
                pozice_tecky = 2;
                zobraz_cislo((pomprom  - 5000 ), 1);

                
              }
            delay(10);  

            if (digitalRead(pin_tl_up) == LOW and digitalRead(pin_tl_dn) == LOW)             // funkce pro prepinani zobrazeni s korekci, nebo bez korekce
              {
                if (s_korekci == true)
                  {
                    s_korekci = false;
                    zobraz_text(32);                                         // "noCor"  (zobrazeni prubezne teploty bez korekce )
                  }
                else
                  {
                    s_korekci = true;
                    zobraz_text(33);                                         // " Corr"  (zobrazeni prubezne teploty s korekci )                    
                  }
                delay(50);
                while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_tl_dn) == LOW) ;     // ceka na uvolneni obou tlacitek
                delay(50);
              }
          }       
      }


    if (polozka == 7)                                                        // vlhkost
      {
        byte pauza = 0;
        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            
            pauza ++;
            if (pauza == 200)                                                // vlhkost se testuje kazde 2 sekundy (200 x 0.01s)
              {
                unsigned int pomprom = vlhkost(); 
                pauza = 0;

                D_pamet[4] = znak_V;                                         // znacka "V" pro mereni vlhkosti na prvni zobrazovaci jednotce
                pozice_tecky = 2;
                zobraz_cislo(pomprom , 1);
              }
            delay(10);  
          } 
      }
        

    if (polozka == 8)                                                        // svetlo
      {
        byte  pauza = 75;
        boolean luxmetr = false;                                             // pri vstupu do teto polozky se zacina vzdycky rezimem SQM
        boolean s_korekci = true;                                            // pri vstupu do polozky se vzdycky nejdriv zobrazuje jas s korekci podle kalibracni tabulky

        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni

            if (luxmetr == false)                                            // je prepnuto na mereni mag/arcsek
              {
                if (pauza == 75)                                             // svetlo se meri po 0,75 sekunde zobrazeni predchoziho mereni (75 x 0.01s)
                  {                
                    pauza = 0;
                    unsigned int pomprom = svetlo_1x(true,false);            // meri jen 1 vzorek - bez bargrafu, je mozne prerusit stiskem tlacitka OK
                    if (pomprom == 65535)  break;                            // mereni bylo predcasne ukonceno tlacitkem, proto se ukonci nadrazena smycka while

                    if (s_korekci == true)                                   // pokud je zapnuty korekcni prepocet ...
                      {
                        pomprom = korekce_svetla(pomprom);                   // ... proved pred zobrazenim korekci podle kalibracni tabulky                
                      }
    
                    pozice_tecky = 3;
                    zobraz_cislo(pomprom , 0);
                  }
                pauza ++;
                delay(10);            

              }
#ifdef zapnout_luxmetr              // !! experimentalni funkce - zatim je vypnuta moznost tuto funkci sustit pres menu
            else                                                             // je prepnuto na luxmetr
              {
                zmer_lux(s_korekci);                                         // zmeri a zobrazi aktualni hodnotu osvetleni v luxech. v pripade potreby si upravi citlivost
              }
#endif

            if (digitalRead(pin_tl_up) == LOW and digitalRead(pin_tl_dn) == LOW)             // funkce pro prepinani zobrazeni s korekci, nebo bez korekce
              {
                if (s_korekci == true)
                  {
                    s_korekci = false;
                    zobraz_text(32);                                         // "noCor"  (zobrazeni prubezneho jasu bez korekce )
                  }
                else
                  {
                    s_korekci = true;
                    zobraz_text(33);                                         // " Corr"  (zobrazeni prubezneho jasu s korekci )                    
                  }
                delay(50);
                while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_tl_dn) == LOW) ;     // ceka na uvolneni obou tlacitek
                delay(50);
              
              }

#ifdef zapnout_luxmetr              // !! experimentalni funkce - zatim je vypnuta moznost tuto funkci sustit pres menu
            if (digitalRead(pin_tl_up) == LOW and digitalRead(pin_tl_dn) == HIGH)             // tlacitko "nahoru" prepina na luxmetr
              {
                luxmetr = true;
                zobraz_text(50);                                                              // "LuXM "  ("LuHM")
                delay(50);
                while (digitalRead(pin_tl_up) == LOW) ;                                       // ceka na uvolneni tlacitka "Nahoru"
                delay(50);
              }

            if (digitalRead(pin_tl_dn) == LOW and digitalRead(pin_tl_up) == HIGH)             // tlacitko "dolu" prepina na mereni v rezimu SQM (mag/arcsek)
              {
                luxmetr = false;
                zobraz_text(51);                                                              // "SQM  "   ("5qM")
                delay(50);
                while (digitalRead(pin_tl_dn) == LOW) ;                                       // ceka na uvolneni tlacitka "dolu"
                delay(50);
              }
#endif
          }              
      }


    if (polozka == 9)                                                        // Ho-Mi
      {
        byte pauza = 0;
        boolean oddelovac_hodin = false;                                     // pomocna promenna pro zjistovani stavu blikajici tecky mezi hodinama a minutama

        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            
            if (millis() % 1000 > 500 and oddelovac_hodin == true)
              {
                oddelovac_hodin = false;
                D_pamet[2] = 0;                                              // pro prostredni displej se zrusi pomlcka mezi hodinami a minutami
                aktualizuj_displej();
              }
            
            if (millis() % 1000 < 500 and oddelovac_hodin == false)
              {
                oddelovac_hodin = true;
                ho_mi();                                                     // zobrazeni udaje "HH-MM" na displeji
              }
          } 
      }


    if (polozka == 10)                                                       // pocet vzorku svetla pro prumerovani svetla
      {
        zadano = plusminus('P', prumery,1,20);
        EEPROM_update(11,zadano & 255);
        prumery = zadano & 255;
      }


    if (polozka == 11)                                                       // funkce LED svitilna
      {
        svitilna();
      }


    if (polozka == 12)                                                       // funkce STOPKY
      {
        stopky();
      }


    if (polozka == 13)                                                       // GPS
      {
        delay(1000);
        gps(0);                                                              // pres I2C si stahne posledni souradnice (zprumerovane), s casem se nic nedeje - RTC se nenastavuje
        int lat_alt_lon = 0;                                                 // znacka, ze se zobrazuje LAT
        disp_GPS(GPS_lat, 0 , true);                                         // na displeji se odscrolluje aktualni zemepisna sirka (LAT)
        byte pocitadlo_smycek = 0;
        while (digitalRead(pin_tl_ok) == HIGH)                               // dokud je tlacitko OK uvolnene, jsou zobrazeny souradnice
          {
            pocitadlo_smycek ++;
            if (pocitadlo_smycek == 40)                                      // kazde 2 sekundy (40*50ms)) se aktualizuji souradnice a potom se zobrazi poslednich 5 mist na displeji
              {
                pocitadlo_smycek = 0;
                gps(0);                                                      // pres I2C si stahne posledni souradnice (zprumerovane), s casem se nic nedeje - RTC se nenastavuje
                
                if (lat_alt_lon == 0) disp_GPS(GPS_lat,  0, false);          // na displeji se zobrazi jen poslednich 5 mist z aktualni zemepisne sirky (LAT) - bez scrollovani
                if (lat_alt_lon == 1) disp_GPS(GPS_alt,  1, false);          // na displeji se zobrazi jen nadmorska vyska (ALT) - bez scrollovani
                if (lat_alt_lon == 2) disp_GPS(GPS_lon,  2, false);          // na displeji se zobrazi jen poslednich 5 mist z aktualni zemepisne delky (LON) - bez scrollovani

              }
            
            
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni            

            if (digitalRead(pin_tl_up) == LOW)                               // prepnuti na nasledujici polozku LAT -> ALT -> LON
              { 
                lat_alt_lon = lat_alt_lon + 1;
                if (lat_alt_lon == 3) lat_alt_lon = 2;
                if (lat_alt_lon == 1)        disp_GPS(GPS_alt, 1, false);    // na displeji se zobrazi aktualni nadmorska vyska (ALT) - bez scrolovani
                if (lat_alt_lon == 2)        disp_GPS(GPS_lon, 2, true);     // na displeji se odscrolluje aktualni zemepisna sirka (LON)
                pocitadlo_smycek = 0;
              }
              
            if (digitalRead(pin_tl_dn) == LOW)                               // prepnuti na predchozi polozku LON -> ALT -> LAT
              {
                lat_alt_lon = lat_alt_lon - 1;
                if (lat_alt_lon < 0) lat_alt_lon = 0;
                if (lat_alt_lon == 0)        disp_GPS(GPS_lat, 0, true);     // na displeji se odscrolluje aktualni zemepisna sirka (LAT) - bez scrolovani
                if (lat_alt_lon == 1)        disp_GPS(GPS_alt, 1, false);    // na displeji se zobrazi aktualni nadmorska vyska (ALT) - bez scrolovani
                pocitadlo_smycek = 0;
              }
              
            while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_tl_dn) == LOW)    // cekani na uvolneni tlacitka UP/DOWN
              {
                delay(50);
              }
            delay(100);          
          } 
        delay(100);

      }



    if (polozka == 14)                                                       // prednastavene pozorovaci stanoviste
      {
        menu_stanoviste();
      }

#ifdef naklonomer
    if (polozka == 22)                                                       // naklonomer
      {
        float akt_naklon;
        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto tlacitko OK
          {
            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            if (digitalRead(pin_tl_up) == LOW)                               // tlacitkem nahoru se meni styl zobrazeni vodovahy
              {
                styl_vodovahy ++;
                if (styl_vodovahy == 3) styl_vodovahy = 0;
                delay(100);
                while (digitalRead(pin_tl_up) == LOW) delay(100);
                delay(100);
              }

            switch (styl_vodovahy)
              {
                case 0:                                                      // jednoduche zobrazeni elevace
                      akt_naklon = (uhel() - 10000);                         // zjisteni aktualniho uhlu zvetseneho o 1000 stupnu v desetinach stupne a prevod na desetinne cislo
          
                      if (digitalRead(pin_tl_dn) == HIGH)                    // zobrazovani probiha jen kdyz je spodni tlacitko uvolnene. Jeho drzeni funguje jako "Data-Hold" a displej se neprekreluje
                        {
                          zobraz_cislo(akt_naklon, 9);                       // zobrazi na displeji uhel na 1 desetinne misto s pripadnym znamenkem na prvni segmentovce a znackou uhlu
                        }
                  break;
    
    
                case 1:                                                      // dvouosa vodovaha polozena horizontalne
                  vodovaha_hor();
                  break;
    
    
                case 2:                                                      // dvouosa vodovaha postavena svisle
                  vodovaha_zen();
                  break;

              }

          }        
        
      }
#endif



    if (polozka == 23)                                                       // elevace Slunce a Mesice
      {

        while (digitalRead(pin_tl_ok) == HIGH)                               // Dokud neni stisknuto tlacitko OK
          {
            if (digitalRead(pin_tl_up) == LOW)                               // tlacitkem nahoru se meni parametr k zobrazeni (elevace Slunce / elevace Mesice / osvetleni Mesice / Azimut Slunce / Azimut Mesice)
              {
                astro_parametr ++;
                if (astro_parametr == 5) astro_parametr = 0;
                delay(100);
                while (digitalRead(pin_tl_up) == LOW) delay(100);
                delay(100);
              }
            if (digitalRead(pin_tl_dn) == LOW)                               // tlacitkem nahoru se meni parametr k zobrazeni (elevace Slunce / elevace Mesice / osvetleni Mesice / Azimut Slunce / Azimut Mesice)
              {
                astro_parametr --;
                if (astro_parametr == -1) astro_parametr = 4;
                delay(100);
                while (digitalRead(pin_tl_dn) == LOW) delay(100);
                delay(100);
              }


            interrupty();                                                    // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni
            zobraz_RTC(false);                                               // aktualizace casovych promennych (LOC_hod, .....)  
            astro_vypocty();                                                 // vypocet vsech elevaci a osvit

            switch (astro_parametr)
              {
                case 0:                                                      // zobrazeni jen elevace Slunce
                  zobraz_cislo(Slu_elevace-90, 10);                                      
                  break;
    
    
                case 1:                                                      // zobrazeni jen elevace Mesice
                  zobraz_cislo(Mes_elevace-90, 11);
                  break;
    
    
                case 2:                                                      // zobrazeni jen osvetleni Mesice
                  zobraz_cislo(Mes_osvit, 12);
                  break;

                case 3:                                                      // zobrazeni jen azimutu Slunce
                  zobraz_cislo(Slu_azimut, 13);
                  break;


                case 4:                                                      // zobrazeni jen azimutu Mesice
                  zobraz_cislo(Mes_azimut, 14);
                  break;


              }
            delay(50);
          }        
        
      }



    if (polozka == 24)                                                           // odpocet
      {
        int odpocet_H;
        int odpocet_M;

        boolean pomprom_save = false;
        unsigned long pomprom_ctdwn = rtc_korekce();
        if (ctdwn_end > pomprom_ctdwn)                                           // nejaky odpocet uz bezi z minula
          {
            odpocet_H = (ctdwn_end - pomprom_ctdwn) / 3600;                      // prepocet rozdilu na cele hodiny
            odpocet_M = ((ctdwn_end - pomprom_ctdwn) - (odpocet_H * 3600UL)) /60;//   a minuty
          }
        else                                                                     // zadny odpocet nebezi, zobrazi se 0
          {
            odpocet_H = 0;
            odpocet_M = 0;
          }        

        odpocet_H = plusminus('H', odpocet_H,0,99);                              // rozsah zadani: 0:00 az 99:59 (neco pres 4 dny)
        if (bude_save == true) pomprom_save = true;

        odpocet_M = plusminus('M', odpocet_M,0,59);
        if (bude_save == true) pomprom_save = true;

        if (pomprom_save == true)
          {
            if (odpocet_H == 0 and odpocet_M == 0)                               // zadanim 0 hodin a 0 minut se odpocet rusi
              {
                ctdwn_end = 0;
              }
            else                                                                 // pri zadani nenulovych hodnot se prepocita za jak dloho se ma alarm spustit
              {
                ctdwn_end = rtc_korekce() + (odpocet_H * 3600UL) + (odpocet_M * 60); // znacka spusteni odpoctu v sekundach od 1.1.1970            
              }
            EEPROM_write_long(  495 ,ctdwn_end);                                 // ulozeni nove hodnoty ciloveho casu do EEPROM
          }
      }


    zobraz_text(pozice_menu1);                                               // po navratu z podmenu se zobrazi aktualne vybrana polozka

    delay(50);
    while (digitalRead(pin_tl_ok) == LOW)                                    // ze zmeny hodnoty polozky se vraci dlouhym stiskem tlacitka OK
      {                                                                      //  ted je nutne pockat na jeho uvolneni
        delay(20);
      }
    
    delay(100);
  }
//------------------------------------------



//------------------------------------------
//  listovani v parametrech zvolene polozky o +/- 1 pomoci tlacitek nahoru adolu
int plusminus(char znak1, byte start_hodnota, int minimum, int maximum)
  {
    int vystup = start_hodnota;
    float potvrzeni = false;

    //--------------------------  zobrazeni puvodni hodnoty na displeji -------------------
    if (znak1 == 'A') D_pamet[4] =  znak_A;                                  // velke A
    if (znak1 == 'P') D_pamet[4] =  znak_P;                                  // velke P
    if (znak1 == 'd') D_pamet[4] =  znak_d;                                  // male d
    if (znak1 == 'M') D_pamet[4] =  znak_M;                                  // velke M
    if (znak1 == 'r') D_pamet[4] =  znak_r;                                  // male r
    if (znak1 == 'H') D_pamet[4] =  znak_H;                                  // velke H
    if (znak1 == 'L') D_pamet[4] =  znak_L;                                  // velke L

    D_pamet[3] = 0b00000000;                                                 // druha sedmisegmentovka zleva (rad tisicu) je prazdna


    if (znak1 == 'S')                                                        // casova zona je trochu jina, protoze nezobrazuje cisla, ale napisy SEC/SELC
      {
        zobraz_text(vystup+25);
      }
    else                                                                     // v ostatnich pripadech se zobrazuje zadavane cislo bez tecky
      {
        pozice_tecky = 0;
        if (znak1 == 'L')
          {
            zobraz_cislo(vystup,2);            
          }
        else
          {
            zobraz_cislo(vystup,1);
          }
      }

    
    while (potvrzeni == false)
      {

        byte pompam4 = D_pamet[4];                                           // zapamatuje se stav displeje pred interruptem, ve kterem muze dojit k jeho zhasnuti
        byte pompam3 = D_pamet[3];                                      
        byte pompam2 = D_pamet[2];
        byte pompam1 = D_pamet[1];
        byte pompam0 = D_pamet[0];
        interrupty();                                                        // odskoceni na test, jestli neni nejaky pozadavek o komunikaci, nebo jestli neni cas spustit automaticke mereni

        D_pamet[0] = pompam0;                                                // po navratu z interruptu zobrazi puvodni stav displeje
        D_pamet[1] = pompam1;
        D_pamet[2] = pompam2;
        D_pamet[3] = pompam3;
        D_pamet[4] = pompam4;
        aktualizuj_displej();

        if (digitalRead(pin_tl_up) == HIGH and digitalRead(pin_tl_dn) == HIGH)    //obe uvolnena tlacitka nahoru a dolu rusi funkci automatickeho listovani
          {
            auto_UD = false;             
          }
        
        if (digitalRead(pin_tl_up) == LOW)                                   // listovani nahoru v polozce
          {
            delay(50);                                                       // odruseni zakmitu

            if (znak1 == 'S')                                                // casova zona je trochu jina, protoze nezobrazuje cisla, ale napisy SEC/SELC
              {
                vystup ++;
                if (vystup > maximum) vystup = maximum;                      // maximum nelze prekrocit
                zobraz_text(vystup+25);
              }
            else
              {
                pozice_tecky = 0;
                if (znak1 == 'L')                                            // prochazeni starych zaznamu ma opacny smer pocitani cisel (tlacitko nahoru ODECITA jednicku)
                  {
                    vystup --;
                    if (vystup < minimum) vystup = maximum;
                    zobraz_cislo(vystup,2);            
                    delay(50);                                               // odruseni zakmitu
                  }
                else                                                         // vsechny ostatni polozky v podmenu se tlacitkem nahoru pricitaji
                  {
                    vystup ++;
                    if (vystup > maximum) vystup = minimum;                  // pri prekroceni maxima se pokracuje od minima
                    zobraz_cislo(vystup,1);
                  }
              }


            cas_UD = 150;                                                    // automaticke pridavani hodnoty pri dlouhem stisku tlacitka nahoru
            start_UD = millis();                                             // znacka pro porovnani, jestli uz doslo k prekroceni pozadovaneho casu
            if (auto_UD == false)                                            // pri prvnim stisku se nastavi delsi cas prepnuti
              {
                auto_UD = true;
                cas_UD = 1000;                                               // cas pred automatickym prepnutim na druhou polozku po stisku tlacitka je trochu delsi
              }


            while (digitalRead(pin_tl_up) == LOW and (millis() - start_UD) < cas_UD)      // dokud je tlacitko stisknute a zaroven nedoslo k vyhodnoceni dlouheho stisku, nic se nedeje
              {
                delay(20);
                if (digitalRead(pin_tl_up) == HIGH) delay(50);               // kdyz se behem drzeni tlacitka UP objevi kratky vypadek kontaktu, tak se odignoruje        
              }
            delay(50);                                                       // odruseni zakmitu
            auto_exit_menu = AUTOEXITMENU;
          }
    
        if (digitalRead(pin_tl_dn) == LOW)                                   // listovani dolu v polozce
          {
            delay(50);                                                       // odruseni zakmitu

            if (znak1 == 'S')                                                // casova zona je trochu jina, protoze nezobrazuje cisla, ale napisy SEC/SELC
              {
                vystup --;
                if (vystup < minimum) vystup = minimum;                      // minimum v teto polozce nelze podlezt
                zobraz_text(vystup+25);
                delay(50);                                                   // odruseni zakmitu
              }
            else
              {
                pozice_tecky = 0;
                if (znak1 == 'L')                                            // listovani ve starych zaznamech ma opacny smer (tlacitko dolu PRICITA jednicku)
                  {
                    vystup ++;
                    if (vystup > maximum) vystup = minimum;                  // po dosazeni maxima se pokracuje od minima
                    zobraz_cislo(vystup,2);            
                    delay(50);                                               // odruseni zakmitu
                  }
                else
                  {
                    vystup --;                                               // vsechny ostatni polozky tlacitkem dolu jednicku normalne ODECITAJI
                    if (vystup < minimum) vystup = maximum;
                    zobraz_cislo(vystup,1);
                    delay(50);                                               // odruseni zakmitu
                  }
              }

            cas_UD = 150;                                                    // automaticke pridavani hodnoty pri dlouhem stisku tlacitka nahoru
            start_UD = millis();                                             // znacka pro porovnani, jestli uz doslo k prekroceni pozadovaneho casu
            if (auto_UD == false)                                            // pri prvnim stisku se nastavi delsi cas prepnuti
              {
                auto_UD = true;
                cas_UD = 1000;                                               // cas pred automatickym prepnutim na druhou polozku po stisku tlacitka je trochu delsi
              }


            while (digitalRead(pin_tl_dn) == LOW and (millis() - start_UD) < cas_UD)      // dokud je tlacitko stisknute a zaroven nedoslo k vyhodnoceni dlouheho stisku, nic se nedeje
              {
                delay(20);
                if (digitalRead(pin_tl_dn) == HIGH) delay(50);               // kdyz se behem drzeni tlacitka DN objevi kratky vypadek kontaktu, tak se odignoruje        
              }
            delay(50);                                                       // odruseni zakmitu
            
            auto_exit_menu = AUTOEXITMENU;    
          }

        if (digitalRead(pin_tl_ok) == LOW)                                   // potvrzovaci tlacitko v polozce
          {
            delay(50);                                                       // odruseni zakmitu
            unsigned long startTime = millis();
            while (digitalRead(pin_tl_ok) == LOW)                            // dokud je tlacitko stisknute, nic se nedeje
              {
                delay(50);
                trvani_stisku2 = millis() - startTime;
                if (trvani_stisku2 > 500)
                  {
                    auto_exit_menu = AUTOEXITMENU;    
                    potvrzeni = true;
                    bude_save = true;
                    if (znak1 == 'L')
                      {
                        zobraz_text(29);                                     // napis "-----"
                      }
                    else
                      {
                        zobraz_text(38);                                     // napis "SAVE"
                      }
                    delay(500);
                    break;
                  }
                if (digitalRead(pin_tl_ok) == HIGH) delay(50);               // kdyz se behem drzeni tlacitka OK objevi kratky vypadek kontaktu, tak se odignoruje         
              }
            if (trvani_stisku2 <= 500)                                       // stisk byl kratsi nez 0,5 sekundy
              {
                delay(200);                                                  // pauza pred opustenim menu
                vystup = start_hodnota;                                      // nastavene cislo se rusi a zustava puvodni
                potvrzeni = true;
                bude_save = false;
              }
          }      
      }
    return vystup;
  }
//------------------------------------------



//------------------------------------------
// podprogram pro postupne odrotovani zaznamu stopek na displeji
// vraci true pri predcasnem ukonceni rolovani pomoci tlacitka OK
//   nebo false po dobehnuti rolovani do konce
boolean disp_zaznam_scroll(byte pocet_znaku)
  {
    pom_disp_scroll[0] = 0;                                                  // prazdna sedmisegmentovka
    pom_disp_scroll[1] = 0;                                                  // prazdna sedmisegmentovka
    pom_disp_scroll[2] = 0;                                                  // prazdna sedmisegmentovka
    pom_disp_scroll[3] = 0;                                                  // prazdna sedmisegmentovka

    for (byte i = 0; i< pocet_znaku - 4 ; i++)
      {
        D_pamet[4] =  pom_disp_scroll[i];
        D_pamet[3] =  pom_disp_scroll[i+1];
        D_pamet[2] =  pom_disp_scroll[i+2];
        D_pamet[1] =  pom_disp_scroll[i+3];
        D_pamet[0] =  pom_disp_scroll[i+4];
        aktualizuj_displej();

        for (byte pauza = 0 ; pauza < 50 ; pauza++)
          {
            delay(10);
            if (i > 2 and digitalRead(pin_tl_ok) == LOW)
              {
                return true;
              }

            if (i > 2 and (digitalRead(pin_tl_dn) == LOW or digitalRead(pin_tl_up) == LOW) )
              {
                return false;
              }
          }
      }
    return false;
  }


void menu_stanoviste(void)
  {
    unsigned long trvani_stisku_stan;
    unsigned int timeout_stan = 600;                                         // timeout se nastavi na  30 sekund (600 x 0,05 sek)

    while (digitalRead(pin_tl_ok) == LOW)                                    // cekani na uvolneni tlacitka OK (displej je od minule zhasnuty)
      {
        delay(50);
      }
    delay(50);                                                               // odruseni zakmitu pri uvolnovani

    int index_pozst = ((EEPROM_read(48) & 0b11100000) >> 5);                 // osekat nejvyssich 5 bitu (aktualne nastavene preddefinovane pozorovaci stanoviste)
    byte pomprom = index_pozst;                                              // do pomocne promenne se ulozi indek stanoviste pri vstupu do podmenu
    for (byte j = 0; j < 5 ; j++)                                            // zobrazeni aktualne nastaveneho stanoviste
      {
        D_pamet[4-j] = EEPROM_read( j + 495 + (index_pozst * 15));
      }
    aktualizuj_displej();

    while (digitalRead(pin_tl_ok) == HIGH and timeout_stan > 0)              // nez dojde k potvrzeni stanoviste tlacitkem OK nebo nez vyprsi timeout, visi program v teto smycce
      {
        timeout_stan --;
        interrupty();                                                        // odskoceni na test zadosti o komunikaci, nebo automaticke mereni
        
        if (digitalRead(pin_tl_up) == LOW and index_pozst < 6 )
          {
            timeout_stan = 600;                                              // obcerstveni timeoutu
            index_pozst ++;
          }

        if (digitalRead(pin_tl_dn) == LOW and index_pozst >= 0 )
          {
            timeout_stan = 600;                                              // obcerstveni timeoutu
            index_pozst --;            
          }
        
        if (index_pozst > 5) index_pozst = 5;                                // zarazka na krajnich indexech 0 az 5
        if (index_pozst < 0) index_pozst = 0;

        if (index_pozst == 0)                                                // index 0 znamena zrusene stanoviste a zobrazi se pomlcky
          {
            zobraz_text(29);                                                 // "-----"
          }
        else                                                                 // pro vyssi indexy se na displeji zobrazi 5-znakove popisky aktualne zvoleneho stanoviste
          {
            for (byte j = 0; j < 5 ; j++)
              {
                D_pamet[4-j] = EEPROM_read( j + 495 + (index_pozst * 15));
              }
            aktualizuj_displej();
          }


        while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_tl_dn) == LOW)     // cekani na uvolneni obou listovacich tlacitek
          {
            delay(50);
          }
        delay(50);                                                           // hlavni casovani pro timeout (600 x 0,05 sek = 30 sekund) 

      }

    if (digitalRead(pin_tl_ok) == LOW)                                       // ukonceni podmenu bylo zpusobeno stiskem tlacitka OK
      {
        delay(50);                                                           // odruseni zakmitu
        unsigned long startTime = millis();
        while (digitalRead(pin_tl_ok) == LOW)                                // dokud je tlacitko stisknute, nic se nedeje
          {
            delay(20);
            trvani_stisku_stan = millis() - startTime;
            if (trvani_stisku_stan > 500)                                    // stisk trval dele nez 0,5 sekundy .... potvrzeni nastaveneho stanoviste
              {
                zobraz_text(38);                                             // napis "Save" se zobrazi vzdycky
                if (index_pozst != pomprom)                                  // ke skutecnemu zapisu ale dochazi jen v pripade, pokud se index pozorovaciho stanoviste zmenil
                  {
                    byte data48 = (EEPROM_read(48) & 0b00011111);
                    data48 = (data48 | (index_pozst << 5) );
                    EEPROM_update(48,data48);
                    delay(500);
                  }
                
              }

            if (digitalRead(pin_tl_ok) == HIGH) delay(50);                   // kdyz se behem drzeni tlacitka OK objevi kratky vypadek kontaktu, tak se odignoruje

          }
        if (trvani_stisku_stan <= 500)                                       // stisk tlacitka OK byl kratsi nez 0,5 sekundy
          {
            zobraz_text(28);                                                 // nic se neuklada, jen se smaze displej a vrati se do hlavniho menu
            delay(100);                                                      // pauza pred opustenim podmenu
          }
        
      }
    
    if (timeout_stan == 0) auto_exit_menu = 1;                               // kdyz vyprsi timeout v tomto podmenu, zrusi se zaroven timeout i v hlavnim menu, takze se provede navrat do hlavni vyckavaci smycky

  
  }



//------------------------------------------
// moznost volby viditelnych polozek v menu
void editace_polozek_menu(void)
  {
    int polozka=0;
    unsigned long menubity;
    zobraz_text(54);                                                         // na displeji se zobrazi napis "MEnu "
    while (digitalRead(pin_tl_up) == LOW or digitalRead(pin_TS) == LOW)      // do teto funkce se vstoupilo stiskem tlacitka UP a bocniho tlacitka pri zapnuti napajeni
      {
        delay(100);                                                          // musi se pockat, dokud se obe tlacitka neuvolni (vcetne odruseni zakmitu)
      }
    delay(100);

    while (true)                                                             // z tohoto podprogramu se vypadne dlouhym stiskem OK
      {
        interrupty();
        if (digitalRead(pin_tl_up) == LOW)                                   // listovani o polozku nahoru (k nizsim indexum) 
          {
            polozka --;
            if (polozka < 0) polozka = 0;
            while (spec_rezim == 0 and polozka > 14 and polozka < 22)        // polozky menu pro specialni funkce se bez zasunuteho HW vubec nezobrazuji
              {
                polozka --;
              }
            delay(100);
            while (digitalRead(pin_tl_up) == LOW)   delay(50);               // cekani na uvolneni tlacitka s odrusenim zakmitu
            delay(100);
          }
    
        if (digitalRead(pin_tl_dn) == LOW)                                   // listovani o polozku nahoru (k nizsim indexum) 
          {
            polozka ++;
            if (polozka > pocet_polozek_v_menu) polozka = pocet_polozek_v_menu;  // maximalni pocet polozek v menu se nesmi prekrocit
            while (spec_rezim == 0 and polozka > 14 and polozka < 22)        // polozky menu pro specialni funkce se bez zasunuteho HW vubec nezobrazuji
              {
                polozka ++;
              }
            delay(100);
            while (digitalRead(pin_tl_dn) == LOW)   delay(50);               // cekani na uvolneni tlacitka s odrusenim zakmitu
            delay(100);
          }

        if (digitalRead(pin_tl_ok) == LOW)                                   // tlacitkem OK se provadi prepinani polozky v menu (viditelna / neviditelna)
          {
            unsigned long ok_casovani = millis();                            // bude se merit delka stisku OK
            delay(100);
            while (digitalRead(pin_tl_ok) == LOW)
              {
                delay(50);                                                   // cekani na uvolneni tlacitka s odrusenim zakmitu
                if (millis() - ok_casovani > 1000)
                  {
                    jas_displeje = 3;                                        // stredni jas displeje
                    zobraz_text(29);                                         // po uplynuti 500ms stisku se na displeji se zobrazi 5 pomlcek
                  }
              }

            if (millis() - ok_casovani < 1000)                               // kratky stisk (do sekundy) ...
              {
                if (menu_enable[polozka] == true)   menu_enable[polozka] = false;   // ... prepina stav mezi "viditelna" / "neviditelna" polozka
                else                                menu_enable[polozka] = true;
              }
            else                                                             // dlouhy stisk ukoncuje nastaveni
              {
                break;                                                       // vypadnuti z while smycky
              }
          }


        
        if (menu_enable[polozka] == true) jas_displeje = 7;                  // povolene polozky menu se zobrazi vysokym jasem
        else                              jas_displeje = 1;                  // zakazane polozky menu se zobrazi nizkym jasem
    
        zobraz_text(polozka);
      }                                                                      // konec smycky, ktera se da breaknout pouze dlouhym stiskem OK
    
    
    while (digitalRead(pin_tl_ok) == LOW)   delay(100);                      // cekani na uvolneni tlacitka OK s odrusenim zakmitu
    delay(100);

                                                                             
    menubity = 0;                                                            // ulozeni nastavenych hodnot do EEPROM (4 bajty po 8 bitech - kazdy bit jedna polozka)
    for (polozka = 0; polozka <= pocet_polozek_v_menu ; polozka ++)
      {
        if (menu_enable[polozka] == true)   bitSet(menubity,polozka);        // priprava 32-bitove promenne
      }
      
    EEPROM_write_long(491 , menubity);                                       // zapis promenne do EEPROM
  }


#endif
